## xen-api-libs 0.5.2

=== camldm/Makefile ===
include ../config.mk

OBJS = camldm
INTF = $(foreach obj, $(OBJS),$(obj).cmi)
LIBS = camldm.cma camldm.cmxa

OCAMLFLAGS = $(RPCLIGHTFLAGS)

all: $(INTF) $(LIBS) $(PROGRAMS)

bins: $(PROGRAMS)

libs: $(LIBS)

camldm.cmxa: libcamldm_stubs.a $(foreach obj,$(OBJS),$(obj).cmx)
	$(OCAMLOPT) $(OCAMLOPTFLAGS) $(OCAMLFLAGS) -a -o $@ -cclib -lcamldm_stubs -cclib -ldevmapper $(foreach obj,$(OBJS),$(obj).cmx)

camldm.cma: $(foreach obj,$(OBJS),$(obj).cmo)
	$(OCAMLC) $(OCAMLOPTFLAGS) $(OCAMLFLAGS) -a -dllib dllcamldm_stubs.so -cclib -lcamldm_stubs -cclib -ldevmapper -o $@ $(foreach obj,$(OBJS),$(obj).cmo)

camldm_stubs.a: camldm_stubs.o
	ocamlmklib -o camldm_stubs -ldevmapper $+

libcamldm_stubs.a: camldm_stubs.o
	ar rcs $@ $+
	ocamlmklib -o camldm_stubs -ldevmapper $+

%.cmo: %.ml
	$(OCAMLC) $(OCAMLFLAGS) -c -o $@ $<

%.cmi: %.mli
	$(OCAMLC) $(OCAMLFLAGS) -c -o $@ $<

%.cmx: %.ml
	$(OCAMLOPT) $(OCAMLOPTFLAGS) $(OCAMLFLAGS) -c -o $@ $<

%.o: %.c
	$(CC) $(CFLAGS) -c -o $@ $<

META: META.in
	sed 's/@VERSION@/$(VERSION)/g' < $< > $@

.PHONY: install
install: $(LIBS) META
	mkdir -p $(OCAMLDESTDIR)
	ocamlfind install -destdir $(OCAMLDESTDIR) -ldconf ignore camldm META $(INTF) $(LIBS) *.a *.so *.cmx $(SPOT)

.PHONY: uninstall
uninstall:
	ocamlfind remove camldm

.PHONY: doc
doc: $(INTF)
	python ../doc/doc.py $(DOCDIR) "camldm" "package" "$(OBJS)" "." "" ""

clean:
	rm -f META *.o *.so *.a *.cmo *.cmi *.cma *.cmx *.cmxa *.annot $(SPOT) $(LIBS) $(PROGRAMS)

=== cdrom/Makefile ===
include ../config.mk

OBJS = cdrom
INTF = $(foreach obj, $(OBJS),$(obj).cmi)
LIBS = cdrom.cma cdrom.cmxa

all: $(INTF) $(LIBS) $(PROGRAMS)

bins: $(PROGRAMS)

libs: $(LIBS)

cdrom.cmxa: libcdrom_stubs.a $(foreach obj,$(OBJS),$(obj).cmx)
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -a -o $@ -cclib -lcdrom_stubs $(foreach obj,$(OBJS),$(obj).cmx)

cdrom.cma: $(foreach obj,$(OBJS),$(obj).cmo)
	$(OCAMLC) -a -dllib dllcdrom_stubs.so -cclib -lcdrom_stubs -o $@ $(foreach obj,$(OBJS),$(obj).cmo)

cdrom_stubs.a: cdrom_stubs.o
	ocamlmklib -o cdrom_stubs $+

libcdrom_stubs.a: cdrom_stubs.o
	ar rcs $@ $+
	ocamlmklib -o cdrom_stubs $+

%.cmo: %.ml
	$(OCAMLC) -c -o $@ $<

%.cmi: %.mli
	$(OCAMLC) -c -o $@ $<

%.cmx: %.ml
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -c -o $@ $<

%.o: %.c
	$(CC) $(CFLAGS) -c -o $@ $<

META: META.in
	sed 's/@VERSION@/$(VERSION)/g' < $< > $@

.PHONY: install
install: $(LIBS) META
	mkdir -p $(OCAMLDESTDIR)
	ocamlfind install -destdir $(OCAMLDESTDIR) -ldconf ignore cdrom META $(INTF) $(LIBS) *.a *.so *.cmx $(SPOT)

.PHONY: uninstall
uninstall:
	ocamlfind remove cdrom

.PHONY: doc
doc: $(INTF)
	python ../doc/doc.py $(DOCDIR) "cdrom" "package" "$(OBJS)" "." "" ""

clean:
	rm -f META *.o *.so *.a *.cmo *.cmi *.cma *.cmx *.cmxa *.annot $(SPOT) $(LIBS) $(PROGRAMS)

=== close-and-exec/Makefile ===
include ../config.mk

IPROG=install -m 755 


OBJS = closeandexec
INTF = $(foreach obj, $(OBJS),$(obj).cmi)
LIBS = closeandexec.cmxa closeandexec.cma

PROGRAMS = closeandexec

all: $(INTF) $(LIBS)

bins: $(PROGRAMS)

libs: $(LIBS)

closeandexec: closeandexec.cmxa closeandexec_main.cmx all
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -thread -I ../stdext -I ../uuid uuid.cmxa unix.cmxa threads.cmxa stdext.cmxa closeandexec.cmxa closeandexec_main.cmx -o $@

closeandexec.cmxa: $(foreach obj,$(OBJS),$(obj).cmx)
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -a -o $@ $(foreach obj,$(OBJS),$(obj).cmx)

closeandexec.cma: $(foreach obj,$(OBJS),$(obj).cmo)
	$(OCAMLC) -a -o $@ $(foreach obj,$(OBJS),$(obj).cmo)

%.cmo: %.ml
	$(OCAMLC) -c -I ../stdext -thread -o $@ $<

%.cmi: %.mli
	$(OCAMLC) -c -I ../stdext -o $@ $<

%.cmx: %.ml
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -c -I ../stdext -thread -o $@ $<

%.o: %.c
	$(CC) $(CFLAGS) -c -o $@ $<

META: META.in
	sed 's/@VERSION@/$(VERSION)/g' < $< > $@

.PHONY: install
install: $(LIBS) META
	mkdir -p $(OCAMLDESTDIR)
	ocamlfind install -destdir $(OCAMLDESTDIR) -ldconf ignore close-and-exec META $(INTF) $(LIBS) *.a *.cmx $(SPOT)

.PHONY: bininstall
bininstall: path = $(DESTDIR)$(LIBEXEC)
bininstall: all
	mkdir -p $(path)
	$(IPROG) $(PROGRAMS) $(path)

.PHONY: uninstall
uninstall:
	ocamlfind remove close-and-exec

.PHONY: binuninstall
binuninstall:
	rm -f $(DESTDIR)$(LIBEXEC)$(PROGRAMS)

.PHONY: doc
doc: $(INTF)
	python ../doc/doc.py $(DOCDIR) "close-and-exec" "library" "$(OBJS)" "." "stdext" ""

clean:
	rm -f META *.o *.so *.a *.cmo *.cmi *.cma *.cmx *.cmxa *.annot $(SPOT) $(LIBS) $(PROGRAMS)

=== cpuid/Makefile ===
include ../config.mk

INCLUDES = -I ../stdext $(OCAML_XC_INC) -I ../xen-utils

OBJS = cpuid
INTF = $(foreach obj, $(OBJS),$(obj).cmi)
LIBS = cpuid.cma cpuid.cmxa

all: $(INTF) $(LIBS) $(PROGRAMS)

bins: $(PROGRAMS)

libs: $(LIBS)

cpuid.cmxa: cpuid_stubs.a $(foreach obj,$(OBJS),$(obj).cmx)
	$(OCAMLOPT) $(OCAMLOPTFLAGS) $(INCLUDES) -a -o $@ -cclib -lcpuid_stubs $(foreach obj,$(OBJS),$(obj).cmx)

cpuid.cma: $(foreach obj,$(OBJS),$(obj).cmo)
	$(OCAMLC) -a -dllib dllcpuid_stubs.so -cclib -lcpuid_stubs $(INCLUDES) -o $@ $(foreach obj,$(OBJS),$(obj).cmo)

cpuid_stubs.a: cpuid_stubs.o
	ocamlmklib -o cpuid_stubs $+

libcpuid_stubs.a: cpuid_stubs.o
	ar rcs $@ $+
	ocamlmklib -o cpuid_stubs $+

%.cmo: %.ml
	$(OCAMLC) $(INCLUDES) -c -o $@ $<

%.cmi: %.mli
	$(OCAMLC) $(INCLUDES) -c -o $@ $<

%.cmx: %.ml
	$(OCAMLOPT) $(OCAMLOPTFLAGS) $(INCLUDES) -c -o $@ $<

%.o: %.c
	$(CC) $(CFLAGS) -c -o $@ $<

META: META.in
	sed 's/@VERSION@/$(VERSION)/g' < $< > $@

.PHONY: install
install: $(LIBS) META
	mkdir -p $(OCAMLDESTDIR)
	ocamlfind install -destdir $(OCAMLDESTDIR) -ldconf ignore cpuid META $(INTF) $(LIBS) *.a *.so *.cmx $(SPOT)

.PHONY: uninstall
uninstall:
	ocamlfind remove cpuid

.PHONY: doc
doc: $(INTF)
	python ../doc/doc.py $(DOCDIR) "cpuid" "package" "$(OBJS)" "." "stdext xenctrl xen-utils" ""

clean:
	rm -f META *.o *.so *.a *.cmo *.cmi *.cma *.cmx *.cmxa *.annot $(SPOT) $(LIBS) $(PROGRAMS) *~ *.rej

=== doc/Makefile ===
include ../config.mk

.PHONY: clean
clean:
	rm -rf components.js content

=== forking_executioner/Makefile ===
include ../config.mk

IPROG=install -m 755

INIT_D   = /etc/rc.d/init.d

OBJS = 
INTF = $(foreach obj, $(OBJS),$(obj).cmi)
LIBS = 

PROGRAMS = fe

all: $(INTF) $(LIBS) $(PROGRAMS)

bins: $(PROGRAMS)

libs: $(LIBS)

test_forker: test_forker.cmx
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -I ../rpc-light -I ../uuid -I ../stdext uuid.cmxa rpc.cmx jsonrpc.cmx -I ../log unix.cmxa stdext.cmxa  test_forker.cmx -o $@

fe: fe_debug.cmx child.cmx fe_main.cmx
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -I ../rpc-light -I ../stdext -I ../uuid  -I ../log log.cmxa uuid.cmxa unix.cmxa rpc.cmx jsonrpc.cmx stdext.cmxa fe_debug.cmx child.cmx fe_main.cmx -o $@

%.cmo: %.ml
	$(OCAMLC) -c -I ../log -I ../uuid -I ../stdext -thread -o $@  $<

%.cmi: %.mli
	$(OCAMLC) -c -I ../log -I ../uuid -I ../stdext -o $@  $<

%.cmx: %.ml
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -I ../log -I ../uuid -c -I ../stdext -o $@ $<

META: META.in
	sed 's/@VERSION@/$(VERSION)/g' < $< > $@

.PHONY: install
install: 

.PHONY: bininstall
bininstall: path = $(DESTDIR)$(LIBEXEC)
bininstall: all
	mkdir -p $(DESTDIR)$(LIBEXEC)
	$(IPROG) $(PROGRAMS) $(DESTDIR)$(LIBEXEC)
	mkdir -p $(DESTDIR)$(INIT_D)
	$(IPROG) init.d-fe $(DESTDIR)$(INIT_D)/fe

.PHONY: uninstall
uninstall:

.PHONY: binuninstall
binuninstall:
	rm -f $(DESTDIR)$(LIBEXEC)$(PROGRAMS)
	rm -f $(DESTDIR)$(INIT_D)/fe

.PHONY: doc
doc: 

clean:
	rm -f *.o *.so *.a *.cmo *.cmi *.cma *.cmx *.cmxa *.annot $(SPOT) $(LIBS) $(PROGRAMS)

=== http-svr/Makefile ===
include ../config.mk

OBJS = radix_tree server_io buf_io http http_svr http_client test_server test_client xMLRPC xmlrpc_client ws_helpers
INTF = $(foreach obj, $(OBJS),$(obj).cmi)
LIBS = http_svr.cma http_svr.cmxa
PROGRAMS = test_server radix_tree http_test


DOCDIR = ../doc

all: $(INTF) $(LIBS)

bins: $(PROGRAMS)

libs: $(LIBS)

radix_tree.opt: radix_tree.cmx radix_tree_test.cmx
	$(OCAMLFIND) $(OCAMLOPT) $(OCAMLOPTFLAGS) -package "stdext,unix" -linkpkg -o $@ radix_tree.cmx radix_tree_test.cmx

test: http_test.opt
	./http_test.opt

http_test.opt: http_svr.cmxa http_test.cmx
	$(OCAMLFIND) $(OCAMLOPT) $(OCAMLOPTFLAGS) -package "unix,threads,oUnit" -thread -linkpkg -o $@ ../rpc-light/rpc.cmx ../uuid/uuid.cmxa -cclib -L../stdext ../stdext/stdext.cmxa -cclib -L../log ../log/log.cmxa  http_svr.cmxa http_test.cmx

test_server.opt: http_svr.cmxa test_server.cmx
	$(OCAMLFIND) $(OCAMLOPT) $(OCAMLOPTFLAGS) -package "stdext,unix,threads" -thread -linkpkg -o $@ -cclib -L../log ../log/log.cmxa http_svr.cmxa test_server.cmx

test_client.opt: http_svr.cmxa test_client.cmx
	$(OCAMLFIND) $(OCAMLOPT) $(OCAMLOPTFLAGS) -package "stdext,unix,threads" -thread -linkpkg -o $@ -cclib -L../log ../log/log.cmxa ../stunnel/stunnel.cmxa http_svr.cmxa test_client.cmx

http_svr.cmxa: $(foreach obj,$(OBJS),$(obj).cmx)
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -a -o $@ $(foreach obj,$(OBJS),$(obj).cmx)

http_svr.cma: $(foreach obj,$(OBJS),$(obj).cmo)
	$(OCAMLC) -a -o $@ $(foreach obj,$(OBJS),$(obj).cmo)

%.cmo: %.ml %.cmi
	$(OCAMLC) -c $(RPCLIGHTFLAGS) -thread -I ../rpc-light -I ../stdext -I ../log -I ../stunnel -o $@ $<

%.cmi: %.mli
	$(OCAMLC) -c -I ../rpc-light -thread -o $@ $<

%.cmx: %.ml %.cmi
	$(OCAMLFIND) $(OCAMLOPT) $(OCAMLOPTFLAGS) $(RPCLIGHTFLAGS) -package "oUnit" -c -thread -I ../rpc-light -I ../stdext -I ../log -I ../stunnel -o $@ $<

%.o: %.c
	$(CC) $(CFLAGS) -c -o $@ $<

META: META.in
	sed 's/@VERSION@/$(VERSION)/g' < $< > $@

.PHONY: install
install: $(LIBS) META
	mkdir -p $(OCAMLDESTDIR)
	ocamlfind install -destdir $(OCAMLDESTDIR) -ldconf ignore http-svr META $(INTF) $(LIBS) *.a *.cmx $(SPOT)

.PHONY: uninstall
uninstall:
	ocamlfind remove http-svr

.PHONY: doc
doc: $(INTF)
	python ../doc/doc.py $(DOCDIR) "http-svr" "package" "$(OBJS)" "." "log,stdext" ""

clean:
	rm -f META *.o *.so *.a *.cmo *.cmi *.cma *.cmx *.cmxa *.annot $(SPOT) $(LIBS) $(PROGRAMS)

=== log/Makefile ===
include ../config.mk

OBJS = syslog log logs debug
INTF = log.cmi logs.cmi syslog.cmi debug.cmi
LIBS = log.cma log.cmxa

OCAMLCFLAGS += -thread -I ../stdext
OCAMLOPTFLAGS += -thread -I ../stdext

all: $(INTF) $(LIBS) $(PROGRAMS)

bins: $(PROGRAMS)

libs: $(LIBS)

log.cmxa: libsyslog_stubs.a $(foreach obj,$(OBJS),$(obj).cmx)
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -a -o $@ -cclib -lsyslog_stubs $(foreach obj,$(OBJS),$(obj).cmx)

log.cma: $(foreach obj,$(OBJS),$(obj).cmo)
	$(OCAMLC) -a -dllib dllsyslog_stubs.so -cclib -lsyslog_stubs -o $@ $(foreach obj,$(OBJS),$(obj).cmo)

syslog_stubs.a: syslog_stubs.o
	ocamlmklib -o syslog_stubs $+

libsyslog_stubs.a: syslog_stubs.o
	ar rcs $@ $+
	ocamlmklib -o syslog_stubs $+

%.cmi: %.mli
	$(OCAMLC) -c $(OCAMLCFLAGS) -o $@ $<

%.cmo: %.ml %.cmi
	$(OCAMLC) -c $(OCAMLCFLAGS) -thread -o $@ $<

%.cmx: %.ml %.cmi
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -thread -c -o $@ $<

%.o: %.c
	$(CC) $(CFLAGS) -c -o $@ $<

META: META.in
	sed 's/@VERSION@/$(VERSION)/g' < $< > $@

#dependency:
log.cmi: syslog.cmi
logs.cmi: log.cmi
debug.cmi: logs.cmi

.PHONY: install
install: $(LIBS) META
	mkdir -p $(OCAMLDESTDIR)
	ocamlfind install -destdir $(OCAMLDESTDIR) -ldconf ignore log META $(INTF) $(LIBS) *.a *.so *.cmx $(SPOT)

.PHONY: uninstall
uninstall:
	ocamlfind remove log

.PHONY: doc
doc: $(INTF)
	python ../doc/doc.py $(DOCDIR) "log" "package" "$(OBJS)" "." "stdext" ""

clean:
	rm -f META *.o *.so *.a *.cmo *.cmi *.cma *.cmx *.cmxa *.annot $(SPOT) $(LIBS) $(PROGRAMS)

=== mk/Makefile ===
ifdef B_BASE
include $(B_BASE)/common.mk
include $(B_BASE)/rpmbuild.mk
REPO = $(call gitloc,xen-api-libs)
else
REPO ?= $(CURDIR)
%/.dirstamp:
	@mkdir -p $*
	@touch $@
endif
RPM_SPECSDIR?=$(shell rpm --eval='%_specdir')
RPM_SRPMSDIR?=$(shell rpm --eval='%_srcrpmdir')
RPM_SOURCESDIR?=$(shell rpm --eval='%_sourcedir')
RPM_RPMSDIR?=$(shell rpm --eval='%_rpmdir')
RPMBUILD?=rpmbuild

XAPI_LIBS_RELEASE=$(shell git rev-list HEAD | wc -l )
RPM_BINDIR=$(RPM_RPMSDIR)/$(DOMAIN0_ARCH_OPTIMIZED)
SPECNAME=xapi-libs.spec

.PHONY: build
build: $(MY_SOURCES)/MANIFEST rpm

.PHONY: rpm
rpm:
	mkdir -p $(RPM_RPMSDIR)
	$(MAKE) -C $(REPO) -f Makefile.xcp srpm
	mkdir -p $(RPM_RPMSDIR)/$(DOMAIN_ZERO_OPTIMIZED)
	$(RPMBUILD) --target $(DOMAIN0_ARCH_OPTIMIZED) -bb  $(RPM_SPECSDIR)/$(SPECNAME)
	mkdir -p $(MY_MAIN_PACKAGES)
	cp $(RPM_RPMSDIR)/$(DOMAIN0_ARCH_OPTIMIZED)/xapi-libs-fe-*.rpm $(MY_MAIN_PACKAGES)

$(MY_SOURCES)/MANIFEST: rpm $(MY_SOURCES_DIRSTAMP)
	rm -f $@
	/bin/sh ./srpms-to-manifest api-libs $(MY_OUTPUT_DIR)/SRPMS > $@

.PHONY: clean
	rm -f *.rpm

=== mlvm/Makefile ===
include ../config.mk

LIBOBJS = constants lvm_uuid crc utils tag absty lvmconfigparser lvmconfiglex lvmmarshal allocator debug redo lv pv vg 
INTF = $(foreach obj, $(LIBOBJS),$(obj).cmi)
CMDOBJS = messages.cmx mlvm.cmx
COMPFLAG = -dtypes -g -I ../stdext -I ../camldm -I ../uuid -for-pack Lvm $(RPCLIGHTFLAGS)

LIBS = lvm.cma lvm.cmxa

default : $(LIBS)

test_allocator: default
	$(OCAMLOPT) -package kaputt -linkpkg -dtypes -g  -I ../stdext -I ../camldm -I ../uuid -I +kaputt unix.cmxa ../rpc-light/rpc.cmx ../rpc-light/jsonrpc.cmx ../camldm/camldm.cmxa ../uuid/uuid.cmxa ../stdext/stdext.cmxa ./lvm.cmxa test_allocator.ml -o $@

lvm.cmx: $(foreach obj,$(LIBOBJS),$(obj).cmx)
	$(OCAMLOPT) -pack -g -o $@ $(foreach obj,$(LIBOBJS),$(obj).cmx)

lvm.cmo: $(foreach obj,$(LIBOBJS),$(obj).cmo)
	$(OCAMLC) -pack -g -o $@ $(foreach obj,$(LIBOBJS),$(obj).cmo)

lvm.cmxa: lvm.cmx
	$(OCAMLOPT) -a -g -o $@ lvm.cmx

lvm.cma: lvm.cmo
	$(OCAMLC) -a -g -o $@ lvm.cmo

META: META.in
	sed 's/@VERSION@/$(VERSION)/g' < $< > $@

.PHONY: install
install: $(LIBS) META
	ocamlfind install -destdir $(OCAMLDESTDIR) -ldconf ignore lvm META lvm.cmi lvm.cmxa lvm.cma lvm.a $(SPOT)

.PHONY: uninstall
uninstall:
	ocamlfind remove lvm

clean : 
	rm -f META *.cmo *.cmi *.cmx *.o *~ *.cma *.cmxa *.a *.annot $(SPOT) lvmconfiglex.ml \
	lvmconfigparser.mli lvmconfigparser.ml
	rm -f test_allocator

.PHONY: doc
doc: $(INTF)
	python ../doc/doc.py $(DOCDIR) "mlvm" "package" "$(LIBOBJS)" "." "rpc-light,stdext,camldm,uuid,unix" ""

lvmconfigparser.ml : lvmconfigparser.mly
	ocamlyacc lvmconfigparser.mly
	$(OCAMLOPT) $(COMPFLAG) -c lvmconfigparser.mli

lvmconfiglex.ml : lvmconfiglex.mll lvmconfigparser.mli
	ocamllex lvmconfiglex.mll

.SUFFIXES: .ml .mli .cmo .cmi .cmx

.ml.cmo:
	$(OCAMLC) $(COMPFLAG) -c $<

.mli.cmi:
	$(OCAMLOPT) $(COMPFLAG) -c $<

.ml.cmx:
	$(OCAMLOPT) $(COMPFLAG) -c $<

.c.o:
	$(OCAMLC) $(COMPFLAG) -c $<

lvmcmd.cmo: messages.cmo 
lvmcmd.cmx: messages.cmx 
lv.cmo: absty.cmo 
lv.cmx: absty.cmx 
mlvm.cmo: vg.cmo pv.cmo messages.cmo lv.cmo 
mlvm.cmx: vg.cmx pv.cmx messages.cmx lv.cmx 
pv.cmo: utils.cmo lvmmarshal.cmo lvm_uuid.cmo crc.cmo constants.cmo \
    allocator.cmo absty.cmo 
pv.cmx: utils.cmx lvmmarshal.cmx lvm_uuid.cmx crc.cmx constants.cmx \
    allocator.cmx absty.cmx 
vg.cmo: debug.cmo pv.cmo lvm_uuid.cmo lv.cmo allocator.cmo absty.cmo 
vg.cmx: debug.cmx pv.cmx lvm_uuid.cmx lv.cmx allocator.cmx absty.cmx 
redo.cmo: tag.cmi debug.cmo allocator.cmo
redo.cmx: tag.cmx debug.cmx allocator.cmx
tag.cmo: debug.cmo tag.cmi
tag.cmx: debug.cmx tag.cmi

test_allocator: default
	$(OCAMLOPT) -package kaputt -linkpkg -dtypes -g  -I ../stdext -I ../camldm -I ../uuid -I +kaputt $(INCLUDES) ./lvm.cmxa test_allocator.ml -o $@

INCLUDES = unix.cmxa ../rpc-light/rpc.cmx ../rpc-light/jsonrpc.cmx ../camldm/camldm.cmxa ../uuid/uuid.cmxa ../stdext/stdext.cmxa

test_fragment: lvm.cmxa $(LIBCMXS) test_fragment.ml
	$(OCAMLOPT) $(COMPFLAG) $(INCLUDES) $^ -o $@

tag_is_valid_test: $(LIBCMXS) tag.cmx tag_is_valid_test.ml
	$(OCAMLOPT) $(COMPFLAG) $(INCLUDES) $^ -o $@

=== pciutil/Makefile ===
include ../config.mk

IPROG=install -m 755


OBJS = pciutil
INTF = $(foreach obj, $(OBJS),$(obj).cmi)
LIBS = pciutil.cma pciutil.cmxa

PROGRAMS = pciutil

all: $(INTF) $(LIBS)

bins: $(PROGRAMS)

libs: $(LIBS)

pciutil: pciutil_main.cmx
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -I ./ -I ../stdext -I ../uuid unix.cmxa uuid.cmxa stdext.cmxa pciutil.cmx -o $@ $^

pciutil.cmxa: $(foreach obj,$(OBJS),$(obj).cmx)
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -a -o $@ $(foreach obj,$(OBJS),$(obj).cmx)

pciutil.cma: $(foreach obj,$(OBJS),$(obj).cmo)
	$(OCAMLC) -a -o $@ $(foreach obj,$(OBJS),$(obj).cmo)

%.cmo: %.ml
	$(OCAMLC) -c -I ../stdext -o $@ $<

%.cmi: %.mli
	$(OCAMLC) -c -I ../stdext -o $@ $<

%.cmx: %.ml
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -c -I ../stdext -o $@ $<

%.o: %.c
	$(CC) $(CFLAGS) -c -o $@ $<

META: META.in
	sed 's/@VERSION@/$(VERSION)/g' < $< > $@

.PHONY: install
install: $(LIBS) META
	mkdir -p $(OCAMLDESTDIR)
	ocamlfind install -destdir $(OCAMLDESTDIR) -ldconf ignore pciutil META $(INTF) $(LIBS) *.a *.cmx $(SPOT)

.PHONY: bininstall
bininstall: path = $(DESTDIR)$(LIBEXEC)
bininstall: all
	mkdir -p $(path)
	$(IPROG) $(PROGRAMS) $(path)

.PHONY: uninstall
uninstall:
	ocamlfind remove pciutil

.PHONY: binuninstall
binuninstall:
	rm -f $(DESTDIR)$(LIBEXEC)$(PROGRAMS)

.PHONY: doc
doc: $(INTF)
	python ../doc/doc.py $(DOCDIR) "pciutil" "package" "$(OBJS)" "." "stdext" ""

clean:
	rm -f META *.o *.so *.a *.cmo *.cmi *.cma *.cmx *.cmxa *.annot $(SPOT) $(LIBS) $(PROGRAMS)

=== rpc-light/Makefile ===
include ../config.mk

OCAMLFLAGS = -annot -g
PACKS = xmlm

ICAMLP4 = -I $(shell ocamlfind query camlp4) -I $(shell ocamlfind query type-conv)
TARGETS = \
	rpc.cmi rpc.cmo rpc.o rpc.cmx \
	pa_rpc.cma idl.cma \
	xmlrpc.cmi xmlrpc.cmo xmlrpc.o xmlrpc.cmx \
	jsonrpc.cmi jsonrpc.cmo jsonrpc.o jsonrpc.cmx

.PHONY: all clean
all: $(TARGETS)

pa_module_conv.cmo: pa_module_conv.ml
	$(OCAMLC) $(OCAMLFLAGS) -c -package camlp4 -pp "camlp4orf" -I $(shell ocamlfind query camlp4) -o $@ $^

pa_rpc.cma: pa_module_conv.cmo rpc.cmo p4_rpc.cmo pa_rpc.cmo
	$(OCAMLC) -a $(ICAMLP4) -o $@ $^

idl.cma: p4_rpc.cmo p4_idl.cmo 
	$(OCAMLC) -a $(ICAMLP4) -o $@ $^

pa_rpc.cmo: pa_rpc.ml p4_rpc.cmo pa_module_conv.cmo
	$(OCAMLC) $(OCAMLFLAGS) -c -package camlp4,type-conv -pp "camlp4orf" $(ICAMLP4) $@ $<

p4_rpc.cmo: p4_rpc.ml rpc.cmo
	$(OCAMLC) $(OCAMLFLAGS) -c -package camlp4,type-conv -pp "camlp4orf" $(ICAMLP4) $@ $<

p4_idl.cmo: p4_idl.ml p4_rpc.cmo
	$(OCAMLC) $(OCAMLFLAGS) -c -package camlp4,type-conv -pp "camlp4orf" $(ICAMLP4) $@ $<

%.o %.cmx: %.ml
	$(OCAMLOPT) $(OCAMLFLAGS) -package $(PACKS) -c -o $@ $<

%.cmo: %.ml
	$(OCAMLC) $(OCAMLFLAGS) -package $(PACKS) -c -o $@ $<

%.cmi: %.mli %.ml
	$(OCAMLOPT) $(OCAMLFLAGS) -package $(PACKS) -c -o $@ $<

META: META.in
	sed 's/@VERSION@/$(VERSION)/g' < $< > $@

.PHONY: install
install: all META
	ocamlfind install -destdir $(OCAMLDESTDIR) rpc-light META $(TARGETS) $(SPOT)

.PHONY: uninstall
uninstall:
	ocamlfind remove rpc-light

.PHONY: doc
doc: $(INTF)
	python ../doc/doc.py $(DOCDIR) "rpc-light" "package" "jsonrpc pa_rpc rpc xmlrpc" "." "xmlm" ""

clean:
	rm -f *.cmo *.cmx *.cma *.cmxa *.annot $(SPOT) *.o *.cmi *.a

=== debian/changelog ===
xen-api-libs (0.5.2-3build1) quantal; urgency=low

  * No-change rebuild against current ocaml libraries.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 21 May 2012 09:24:43 +0200

xen-api-libs (0.5.2-3) unstable; urgency=low

  * Initial release (Closes: #646727).

 -- Jon Ludlam <jon@frankenelmo.uk.xensource.com>  Thu, 08 Dec 2011 11:07:39 +0000

=== debian/control ===
Source: xen-api-libs
Section: libs
Priority: extra
Maintainer: Pkg Xen <pkg-xen-devel@lists.alioth.debian.org>
Build-Depends: debhelper (>= 8), libxen-ocaml-dev, libxen-ocaml, ocaml-nox, camlp4, camlp4-extra, ocaml-findlib, autotools-dev, dh-autoreconf, libtype-conv-camlp4-dev, libxmlm-ocaml-dev, uuid-dev, libdevmapper-dev, libxen-dev, blktap-dev, dh-ocaml, libounit-ocaml-dev
Standards-Version: 3.9.2
Uploaders: Jon Ludlam <jonathan.ludlam@eu.citrix.com>, Thomas Goirand <zigo@debian.org>
Homepage: http://www.xen.org/XCP
Vcs-Git: http://git.debian.org/git/pkg-xen/xen-api-libs.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-xen/xen-api-libs.git;a=summary

Package: libxcp-ocaml
Architecture: any
Section: ocaml
Depends: ${shlibs:Depends}, ${misc:Depends}, ${ocaml:Depends}
Provides: ${ocaml:Provides}
Description: Xen Cloud Platform control stack core libraries (runtime)
 The Xen Cloud Platform (XCP) is an open source enterprise-ready server
 virtualization and cloud computing platform, with support for a range of
 guest operating systems, Linux network and storage support.
 .
 XCP addresses the needs of cloud providers, hosting services and data centers
 by combining the isolation and multitenancy capabilities of the Xen hypervisor
 with enhanced security, storage and network virtualization technologies to
 offer a rich set of virtual infrastructure cloud services. The platform
 also address user requirements for security, availability, performance and
 isolation across both private and public clouds.
 .
 XCP consolidates server workloads, enables savings in power, cooling, and
 management costs and thus contributing to environmentally sustainable
 computing, an increased ability to adapt to ever-changing IT environments,
 an optimized use of existing hardware, and an improved level of IT
 reliability.
 .
 This package contains the runtime libraries required by OCaml bytecode
 programs that link against the XCP OCaml libraries

Package: libxcp-ocaml-dev
Architecture: any
Section: ocaml
Depends: ${misc:Depends}, ${ocaml:Depends}, blktap-dev
Provides: ${ocaml:Provides}
Description: Xen Cloud Platform control stack core libraries (devel)
 The Xen Cloud Platform (XCP) is an open source enterprise-ready server
 virtualization and cloud computing platform, with support for a range of
 guest operating systems, Linux network and storage support.
 .
 XCP addresses the needs of cloud providers, hosting services and data centers
 by combining the isolation and multitenancy capabilities of the Xen hypervisor
 with enhanced security, storage and network virtualization technologies to
 offer a rich set of virtual infrastructure cloud services. The platform
 also address user requirements for security, availability, performance and
 isolation across both private and public clouds.
 .
 XCP consolidates server workloads, enables savings in power, cooling, and
 management costs and thus contributing to environmentally sustainable
 computing, an increased ability to adapt to ever-changing IT environments,
 an optimized use of existing hardware, and an improved level of IT
 reliability.
 .
 This package contains the file required to develop against the OCaml
 libraries provided as part of the XCP xen control stack

Package: xcp-fe
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Fork-and-exec daemon for xapi
 The Xen Cloud Platform (XCP) is an open source enterprise-ready server
 virtualization and cloud computing platform, with support for a range of
 guest operating systems, Linux network and storage support.
 .
 XCP addresses the needs of cloud providers, hosting services and data centers
 by combining the isolation and multitenancy capabilities of the Xen hypervisor
 with enhanced security, storage and network virtualization technologies to
 offer a rich set of virtual infrastructure cloud services. The platform
 also address user requirements for security, availability, performance and
 isolation across both private and public clouds.
 .
 XCP consolidates server workloads, enables savings in power, cooling, and
 management costs and thus contributing to environmentally sustainable
 computing, an increased ability to adapt to ever-changing IT environments,
 an optimized use of existing hardware, and an improved level of IT
 reliability.
 .
 This daemon is the fork-and-exec daemon used by xapi. When xapi requires
 another executable to be run, rather than forking and execing itself, it
 uses this single-threaded daemon to do it, passing fds to it as required.
